/*****************************************************************************
 *
 * grail - Gesture Recognition And Instantiation Library
 *
 * Copyright (C) 2010 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Henrik Rydberg <rydberg@bitmath.org>
 *
 ****************************************************************************/

#ifndef _GRAIL_GESTURE_CLIENT_H
#define _GRAIL_GESTURE_CLIENT_H

#include <gesture.h>

struct gesture_client {
	void (*gesture)(struct gesture_client *client,
			const struct gesture_event *ev);
	int priority[DIM_GESTURE_TYPE];
	struct client_impl *impl;
	void *priv;
};

int client_init(struct gesture_client *client, void *priv);

void client_flag(struct gesture_client *client,
		 const struct gesture_flag *flag);
void client_event(struct gesture_client *client,
		  const struct gesture_event *ev);
void client_sync(struct gesture_client *client);

void client_destroy(struct gesture_client *client);

#endif
