/*****************************************************************************
 *
 * grail - Gesture Recognition And Instantiation Library
 *
 * Copyright (C) 2010 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Henrik Rydberg <rydberg@bitmath.org>
 *
 ****************************************************************************/

#ifndef _GRAIL_GESTURE_DEV_H
#define _GRAIL_GESTURE_DEV_H

#include <gesture-client.h>

struct gesture_dev {
	struct gedev_impl *impl;
	void *priv;
};

int gedev_init(struct gesture_dev *dev, void *priv);
int gedev_attach_client(struct gesture_dev *dev,
			struct gesture_client *client);

void gedev_flag(struct gesture_dev *dev, const struct gesture_flag *flag);
void gedev_event(struct gesture_dev *dev, const struct gesture_event *ev);
void gedev_sync(struct gesture_dev *dev);

void gedev_detach_client(struct gesture_dev *dev,
			 struct gesture_client *client);
void gedev_destroy(struct gesture_dev *dev);

#endif
