/*****************************************************************************
 *
 * grail - Gesture Recognition And Instantiation Library
 *
 * Copyright (C) 2010 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Henrik Rydberg <rydberg@bitmath.org>
 *
 ****************************************************************************/

#ifndef _GRAIL_GESTURE_H
#define _GRAIL_GESTURE_H

#include <touch-dev.h>

#define DIM_GESTURE_PROP 8
typedef int gesture_prop_t;

enum gesture_type {
	GE_MOVE,
	GE_VSCROLL,
	DIM_GESTURE_TYPE
};

enum gesture_state {
	GS_CANCEL,
	GS_BEGIN,
	GS_END
};

struct gesture_flag {
	enum gesture_type type;
	touch_time_t time;
	enum gesture_state state;
};

struct gesture_event {
	enum gesture_type type;
	touch_time_t time;
	gesture_prop_t prop[DIM_GESTURE_PROP];
};

#endif
