/*****************************************************************************
 *
 * grail - Gesture Recognition And Instantiation Library
 *
 * Copyright (C) 2010 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Henrik Rydberg <rydberg@bitmath.org>
 *
 ****************************************************************************/

#ifndef _GRAIL_TOUCH_DEV_H
#define _GRAIL_TOUCH_DEV_H

#include <touch.h>

typedef __u64 touch_time_t;

struct touch_dev {
	void (*event)(struct touch_dev *dev, const struct input_event *ev);
	void (*create)(struct touch_dev *dev, int slot,
		       const touch_prop_mask_t *mask, const touch_prop_t *prop);
	void (*modify)(struct touch_dev *dev, int slot,
		       const touch_prop_mask_t *mask, const touch_prop_t *prop);
	void (*destroy)(struct touch_dev *dev, int slot);
	void (*sync)(struct touch_dev *dev, touch_time_t time);
	struct touch_dev_impl *impl;
	void *priv;
};

int touch_dev_open(struct touch_dev *dev, int fd);
int touch_dev_idle(struct touch_dev *dev, int fd, int ms);
int touch_dev_pull(struct touch_dev *dev, int fd);
void touch_dev_close(struct touch_dev *dev, int fd);

#endif
