/*****************************************************************************
 *
 * grail - Gesture Recognition And Instantiation Library
 *
 * Copyright (C) 2010 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Henrik Rydberg <rydberg@bitmath.org>
 *
 ****************************************************************************/

#ifndef _GRAIL_TOUCH_ENGINE_H
#define _GRAIL_TOUCH_ENGINE_H

#include <touch-dev.h>

#define DIM_TOUCHES 32

struct touch_frame {
	int ntouch;
	int slot;
	struct touch touch[DIM_TOUCHES];
};

static inline int next_slot(const struct touch_frame *frame, int slot)
{
	return frame->touch[slot].next;
}

struct touch_engine {
	void (*sync)(struct touch_engine *engine, touch_time_t time);
	struct touch_frame frame;
	void *priv;
};

void touch_engine_init(struct touch_engine *engine,
		       void (*sync)(struct touch_engine *engine,
				    touch_time_t time),
		       void *priv);
void touch_engine_attach(struct touch_engine *engine, struct touch_dev *dev);
void touch_engine_detach(struct touch_engine *engine, struct touch_dev *dev);

#endif
