/*****************************************************************************
 *
 * grail - Gesture Recognition And Instantiation Library
 *
 * Copyright (C) 2010 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Henrik Rydberg <rydberg@bitmath.org>
 *
 ****************************************************************************/

#ifndef _GRAIL_TOUCH_H
#define _GRAIL_TOUCH_H

#include <mtdev.h>

enum touch_prop_list {
	TP_POS_X,
	TP_POS_Y,
	TP_TOUCH_MAJOR,
	TP_TOUCH_MINOR,
	TP_WIDTH_MAJOR,
	TP_WIDTH_MINOR,
	TP_ORIENTATION,
	TP_PRESSURE,
	DIM_TOUCH_PROP
};

typedef int touch_prop_t;
typedef unsigned touch_prop_mask_t;

struct touch {
	int active;
	int slot;
	int next;
	touch_prop_t prop[DIM_TOUCH_PROP];
};

static inline int has_prop(const touch_prop_mask_t *mask, int code)
{
	return (mask[code >> 5] >> (code & 31)) & 1;
}

#endif
